#!/usr/bin/perl -w

use lib "..";
use HotSaNIC;
use RRDs;
#use DBI;

# get cmdline arguments (i.e. options passed by the daemon)
# and other global parameters
#
%ARGS=arg2opt(@ARGV);

dupe_control("start",$ARGS{"MODNAME"},"");

# read module-specific settings
#
open (FILE,"settings");
while (<FILE>) {
  ($var,$value)=parse_line($_);

  if ($var eq "ALL") {$ALL=$value;}
  if ($var eq "ROUTERS") {$ROUTERS=$value;}
  if ($var eq "CLOUD") {$CLOUD=$value;}
  if ($var eq "DEFAULT") {$DEFAULT=$value;}
  if ($var eq "IFACE") {
     ($iface)=split(/,/,$value);
     push @IFACES,$iface;
     next;
     }
  }
close(FILE);

foreach $iface (@IFACES) {
  if ( ! -e "rrd/$iface.rrd" ) { system("./makerrd","$iface", "U") }

  system("$ALL > $iface.all");
  system("$ROUTERS > $iface.routers");
  system("$CLOUD > $iface.cloud");
  system("$DEFAULT > $iface.default");

  open (FILE,"$iface.all");
  while(<FILE>) {
    $all=$_;
  }
  close(FILE);
  open (FILE,"$iface.routers");
  while(<FILE>) {
    $routers=$_;
  }
  close(FILE);
  open (FILE,"$iface.cloud");
  while(<FILE>) {
    $cloud=$_;
  }
  close(FILE);
  open (FILE,"$iface.default");
  while(<FILE>) {
    $default=$_;
  }
  close(FILE);
  $cloud=$cloud*10;
  $routers=(1+$routers)*100;
  RRDs::update "rrd/$iface.rrd",time.":".$all.":".$routers.":".$cloud.":".$default;
  if ($ERROR = RRDs::error) { dupe_control("warn",$ARGS{"MODNAME"},"unable to update `$iface.rrd': $ERROR"); }
}  

